"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var grommet_1 = require("grommet");
var React = __importStar(require("react"));
var styled_components_1 = __importDefault(require("styled-components"));
var asRendition_1 = __importDefault(require("../asRendition"));
var utils_1 = require("../utils");
var getHoverEffectOverride = function (bg, color, opacity) {
    return "\n\t\t&:hover:enabled,\n\t\t&:focus:enabled,\n\t\t&:active:enabled {\n\t\t\tsvg {\n\t\t\t\tcolor: " + color + " !important;\n\t\t\t}\n\n\t\t\tbox-shadow: none;\n\t\t\tbackground: " + bg + ";\n\t\t\tborder-color: " + bg + ";\n\t\t\tcolor: " + color + ";\n\t\t\topacity: " + opacity + ";\n\t\t}\n\t";
};
var ButtonBase = styled_components_1.default(grommet_1.Button)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tfont-family: ", ";\n\tfont-weight: ", ";\n\tfont-size: ", ";\n\theight: ", ";\n\twhite-space: nowrap;\n\tsvg {\n\t\tcolor: inherit !important;\n\t\tfont-size: 0.925em;\n\t}\n\t/* These rules cause consistent styling when the button is rendered as a link */\n\tdisplay: inline-flex;\n\talign-items: center;\n\tjustify-content: center;\n\n\t&:disabled {\n\t\tcursor: not-allowed;\n\t}\n"], ["\n\tfont-family: ", ";\n\tfont-weight: ", ";\n\tfont-size: ", ";\n\theight: ", ";\n\twhite-space: nowrap;\n\tsvg {\n\t\tcolor: inherit !important;\n\t\tfont-size: 0.925em;\n\t}\n\t/* These rules cause consistent styling when the button is rendered as a link */\n\tdisplay: inline-flex;\n\talign-items: center;\n\tjustify-content: center;\n\n\t&:disabled {\n\t\tcursor: not-allowed;\n\t}\n"])), function (props) { return props.theme.titleFont; }, function (props) { return props.theme.button.font.weight; }, function (props) { return utils_1.px(props.theme.fontSizes[1]); }, function (props) { return props.theme.button.height; });
var ColouredButton = styled_components_1.default(ButtonBase)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\tcolor: ", ";\n\t", ";\n"], ["\n\tcolor: ",
    ";\n\t",
    ";\n"])), function (props) {
    return utils_1.isLight(utils_1.getColor(props, 'color', 'main'))
        ? props.theme.colors.text.main
        : 'white';
}, function (props) {
    var color = utils_1.getColor(props, 'color', 'dark');
    return getHoverEffectOverride(color, utils_1.isLight(color) ? props.theme.colors.text.main : 'white');
});
var Outline = styled_components_1.default(ButtonBase)(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n\tcolor: ", ";\n\tborder-color: ", ";\n\tsvg {\n\t\tcolor: ", " !important;\n\t}\n\t", ";\n"], ["\n\tcolor: ", ";\n\tborder-color: ", ";\n\tsvg {\n\t\tcolor: ", " !important;\n\t}\n\t",
    ";\n"])), function (props) { return props.theme.colors.text.main; }, function (props) { return props.color || props.theme.colors.text.main; }, function (props) { return props.theme.colors.tertiary.main; }, function (props) {
    return getHoverEffectOverride(props.color || props.theme.colors.text.main, utils_1.isLight(props.color) ? props.theme.colors.text.main : 'white');
});
var Light = styled_components_1.default(ButtonBase)(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n\tcolor: ", ";\n\tborder-color: ", ";\n\tbackground: white;\n\tborder: none;\n\t", ";\n\n\t&:disabled {\n\t\topacity: 1;\n\t\tcolor: #c6c8c9;\n\t}\n"], ["\n\tcolor: ", ";\n\tborder-color: ", ";\n\tbackground: white;\n\tborder: none;\n\t",
    ";\n\n\t&:disabled {\n\t\topacity: 1;\n\t\tcolor: #c6c8c9;\n\t}\n"])), function (props) { return props.theme.colors.text.main; }, function (props) { return props.theme.colors.text.main; }, function (props) {
    return getHoverEffectOverride('white', props.theme.colors.secondary.main, '0.9');
});
var LightOutline = styled_components_1.default(Light)(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n\tcolor: white;\n\tborder: 1px solid white;\n\tbackground: transparent;\n\t", ";\n\n\t&:disabled {\n\t\topacity: 1;\n\t\tcolor: #c6c8c9;\n\t}\n"], ["\n\tcolor: white;\n\tborder: 1px solid white;\n\tbackground: transparent;\n\t",
    ";\n\n\t&:disabled {\n\t\topacity: 1;\n\t\tcolor: #c6c8c9;\n\t}\n"])), function (props) {
    return getHoverEffectOverride('white', props.theme.colors.secondary.main, '0.9');
});
var Plain = styled_components_1.default(ButtonBase)(templateObject_6 || (templateObject_6 = __makeTemplateObject(["\n\tcolor: ", ";\n\theight: auto;\n\tfont-weight: ", ";\n\tborder-radius: 0;\n\t", ";\n"], ["\n\tcolor: ", ";\n\theight: auto;\n\tfont-weight: ", ";\n\tborder-radius: 0;\n\t",
    ";\n"])), function (props) { return props.color || props.theme.colors.text.main; }, function (props) { return props.theme.button.font.weight; }, function (props) {
    return getHoverEffectOverride('none', props.hoverColor || props.theme.colors.text.light);
});
var underlineButtonActiveStyles = function (props) { return "\n\tcolor: " + (props.color || props.theme.colors.text.main) + ";\n\tbackground: none;\n\tbox-shadow: 0px -1px 0 0px inset;\n"; };
var Underline = styled_components_1.default(Plain)(templateObject_7 || (templateObject_7 = __makeTemplateObject(["\n\t", "\n\tborder-bottom: 1px solid;\n\tbackground: none;\n\t&:hover:enabled,\n\t&:focus:enabled,\n\t&:active:enabled {\n\t\t", ";\n\t}\n"], ["\n\t", "\n\tborder-bottom: 1px solid;\n\tbackground: none;\n\t&:hover:enabled,\n\t&:focus:enabled,\n\t&:active:enabled {\n\t\t", ";\n\t}\n"])), function (props) { return (props.active ? underlineButtonActiveStyles(props) : ''); }, underlineButtonActiveStyles);
var getStyledButton = function (_a, isPrimary) {
    var outline = _a.outline, underline = _a.underline, plain = _a.plain, active = _a.active, light = _a.light, originalProps = __rest(_a, ["outline", "underline", "plain", "active", "light"]);
    if (plain) {
        return function (props) { return (React.createElement(Plain, __assign({}, props, { color: utils_1.getColor(originalProps, 'color', 'main'), hoverColor: utils_1.getColor(originalProps, 'color', 'dark') }))); };
    }
    if (light) {
        if (outline) {
            return LightOutline;
        }
        return Light;
    }
    if (underline) {
        return function (props) { return (React.createElement(Underline, __assign({}, props, { plain: true, color: utils_1.getColor(originalProps, 'color', 'main') }))); };
    }
    if ((outline && !active) || !isPrimary) {
        return function (props) { return (React.createElement(Outline, __assign({}, props, { color: utils_1.getColor(originalProps, 'color', 'main') }))); };
    }
    return ColouredButton;
};
var Base = function (props) {
    var outline = props.outline, underline = props.underline, children = props.children, label = props.label, primary = props.primary, color = props.color, plain = props.plain, active = props.active, light = props.light, restProps = __rest(props, ["outline", "underline", "children", "label", "primary", "color", "plain", "active", "light"]);
    var basePrimary = !!props.bg ||
        (!!utils_1.getColoringType(props) && !outline && !underline && !props.plain);
    var baseColor = props.bg || utils_1.getColor(props, 'bg', 'main');
    var secondary = baseColor ? false : true;
    baseColor = baseColor || props.theme.colors.secondary.main;
    if (active) {
        basePrimary = !basePrimary;
    }
    var StyledButton = getStyledButton(__assign({ secondary: secondary }, props), basePrimary);
    return (React.createElement(StyledButton, __assign({ primary: basePrimary, color: baseColor, active: active && (underline || plain), gap: utils_1.px(props.theme.space[2]) }, restProps, { plain: !!plain || !!underline, label: label || children })));
};
exports.default = asRendition_1.default(Base, [], ['width', 'color', 'bg']);
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6, templateObject_7;
