import * as tslib_1 from "tslib";
import cloneDeep from 'lodash/cloneDeep';
import groupBy from 'lodash/groupBy';
import map from 'lodash/map';
import * as React from 'react';
import FaPieChart from 'react-icons/lib/fa/pie-chart';
import FaTrash from 'react-icons/lib/fa/trash';
import styled from 'styled-components';
import DropDownButton from '../DropDownButton';
import { Box } from '../Grid';
import Txt from '../Txt';
import FilterDescription from './FilterDescription';
var Wrapper = styled.div(templateObject_1 || (templateObject_1 = tslib_1.__makeTemplateObject([""], [""])));
var UnstyledList = styled.ul(templateObject_2 || (templateObject_2 = tslib_1.__makeTemplateObject(["\n\tlist-style: none;\n\tpadding: 0 !important;\n\tmargin: 0;\n"], ["\n\tlist-style: none;\n\tpadding: 0 !important;\n\tmargin: 0;\n"])));
var PlainPanel = styled.div(templateObject_3 || (templateObject_3 = tslib_1.__makeTemplateObject(["\n\tborder-radius: 2px;\n\tbackground-color: #ffffff;\n\tbox-shadow: 0 0 6px 0 rgba(0, 0, 0, 0.1);\n\tborder: solid 1px #9b9b9b;\n"], ["\n\tborder-radius: 2px;\n\tbackground-color: #ffffff;\n\tbox-shadow: 0 0 6px 0 rgba(0, 0, 0, 0.1);\n\tborder: solid 1px #9b9b9b;\n"])));
var Preview = styled(PlainPanel)(templateObject_4 || (templateObject_4 = tslib_1.__makeTemplateObject(["\n\tdisplay: none;\n\tposition: absolute;\n\tright: 230px;\n\twidth: 300px;\n\tright: 100%;\n\tmargin-right: 3px;\n\ttop: 2px;\n\tpadding: 15px 15px 5px;\n"], ["\n\tdisplay: none;\n\tposition: absolute;\n\tright: 230px;\n\twidth: 300px;\n\tright: 100%;\n\tmargin-right: 3px;\n\ttop: 2px;\n\tpadding: 15px 15px 5px;\n"])));
export var ViewListItem = styled.li(templateObject_5 || (templateObject_5 = tslib_1.__makeTemplateObject(["\n\tposition: relative;\n\tpadding: 7px 40px 7px 20px;\n\t&:hover {\n\t\tbackground-color: #f3f3f3;\n\t}\n\t& > p {\n\t\tpadding-right: 20px;\n\t}\n\t& > button {\n\t\tposition: absolute;\n\t\ttop: 50%;\n\t\ttransform: translateY(-50%);\n\t\tright: 2px;\n\t\tpadding: 8px;\n\t\tbackground: none;\n\t\tborder: none;\n\t\tdisplay: none;\n\t\tcursor: pointer;\n\t}\n\t&:hover > button {\n\t\tdisplay: block;\n\t\topacity: 0.7;\n\t}\n\t> button:hover {\n\t\topacity: 1;\n\t}\n\t&:hover ", " {\n\t\tdisplay: block;\n\t}\n"], ["\n\tposition: relative;\n\tpadding: 7px 40px 7px 20px;\n\t&:hover {\n\t\tbackground-color: #f3f3f3;\n\t}\n\t& > p {\n\t\tpadding-right: 20px;\n\t}\n\t& > button {\n\t\tposition: absolute;\n\t\ttop: 50%;\n\t\ttransform: translateY(-50%);\n\t\tright: 2px;\n\t\tpadding: 8px;\n\t\tbackground: none;\n\t\tborder: none;\n\t\tdisplay: none;\n\t\tcursor: pointer;\n\t}\n\t&:hover > button {\n\t\tdisplay: block;\n\t\topacity: 0.7;\n\t}\n\t> button:hover {\n\t\topacity: 1;\n\t}\n\t&:hover ", " {\n\t\tdisplay: block;\n\t}\n"])), Preview);
var ViewListItemLabel = styled(Txt)(templateObject_6 || (templateObject_6 = tslib_1.__makeTemplateObject(["\n\tcursor: pointer;\n"], ["\n\tcursor: pointer;\n"])));
var ViewsMenu = (function (_super) {
    tslib_1.__extends(ViewsMenu, _super);
    function ViewsMenu(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            showViewsMenu: false,
        };
        return _this;
    }
    ViewsMenu.prototype.loadView = function (view) {
        var filters = cloneDeep(view.filters);
        this.props.setFilters(filters);
        this.setState({ showViewsMenu: false });
    };
    ViewsMenu.prototype.render = function () {
        var _this = this;
        var _a = this.props, views = _a.views, renderMode = _a.renderMode, hasMultipleScopes = _a.hasMultipleScopes;
        var hasViews = views.length > 0;
        var groupedViews = groupBy(views, function (item) { return item.scope || 'Unscoped'; });
        var soloRender = false;
        if (renderMode) {
            var mode = Array.isArray(renderMode) ? renderMode : [renderMode];
            soloRender = mode.length === 1 && mode[0] === 'views';
        }
        return (React.createElement(Wrapper, null,
            React.createElement(DropDownButton, tslib_1.__assign({ ml: soloRender ? 0 : 30, disabled: this.props.disabled, quartenary: !this.props.dark, light: this.props.dark, outline: true, joined: true, alignRight: !soloRender, noListFormat: true, icon: React.createElement(FaPieChart, null), label: "Views" }, this.props.buttonProps),
                React.createElement(Box, { py: 1 },
                    !hasViews && (React.createElement(Box, { py: 2, px: 3 }, "You haven't created any views yet")),
                    hasViews &&
                        map(groupedViews, function (views, scope) { return (React.createElement(Box, { key: scope },
                            hasMultipleScopes && (React.createElement(Txt, { fontSize: 13, ml: 20, mb: 2, mt: 2, color: "#aaa" }, scope)),
                            React.createElement(UnstyledList, null, views.map(function (view) { return (React.createElement(ViewListItem, { key: view.name },
                                React.createElement(ViewListItemLabel, { m: 0, onClick: function () { return _this.loadView(view); } },
                                    view.name,
                                    React.createElement("br", null),
                                    React.createElement(Txt, { m: 0, fontSize: 12, color: "#aaa" },
                                        view.filters.length,
                                        " filter",
                                        view.filters.length > 1 && 's')),
                                React.createElement("button", { onClick: function () { return _this.props.deleteView(view); } },
                                    React.createElement(FaTrash, { name: "trash" })),
                                React.createElement(Preview, null, view.filters.map(function (filter) { return (React.createElement(Box, { mb: 10, key: filter.$id },
                                    React.createElement(FilterDescription, { filter: filter }))); })))); })))); })))));
    };
    return ViewsMenu;
}(React.Component));
export default ViewsMenu;
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6;
